tamarin-prover-utils-1.2.2: Utility library for the tamarin prover.

Copyright | (c) 2011 Simon Meier
License | GPL v3 (see LICENSE)
Maintainer | Simon Meier <iridcode@gmail.com>
Safe Haskell | Safe
Language | Haskell98

Extension.Data.Bounded

Description

Monoids for bounded types.

Synopsis

- newtype BoundedMax a = BoundedMax {
  - getBoundedMax :: a
  }
- newtype BoundedMin a = BoundedMin {
  - getBoundedMin :: a
  }

# Documentation

newtype BoundedMax a #

A newtype wrapper for a monoid of the maximum of a bounded type.

Constructors

BoundedMax |
Fields getBoundedMax :: a

Instances

Eq a => Eq (BoundedMax a) # |
Methods (==) :: BoundedMax a -> BoundedMax a -> Bool # (/=) :: BoundedMax a -> BoundedMax a -> Bool #
Ord a => Ord (BoundedMax a) # |
Methods compare :: BoundedMax a -> BoundedMax a -> Ordering # (<) :: BoundedMax a -> BoundedMax a -> Bool # (<=) :: BoundedMax a -> BoundedMax a -> Bool # (>) :: BoundedMax a -> BoundedMax a -> Bool # (>=) :: BoundedMax a -> BoundedMax a -> Bool # max :: BoundedMax a -> BoundedMax a -> BoundedMax a # min :: BoundedMax a -> BoundedMax a -> BoundedMax a #
Show a => Show (BoundedMax a) # |
Methods showsPrec :: Int -> BoundedMax a -> ShowS # show :: BoundedMax a -> String # showList :: [BoundedMax a] -> ShowS #
(Ord a, Bounded a) => Monoid (BoundedMax a) # |
Methods mempty :: BoundedMax a # mappend :: BoundedMax a -> BoundedMax a -> BoundedMax a # mconcat :: [BoundedMax a] -> BoundedMax a #

newtype BoundedMin a #

A newtype wrapper for a monoid of the minimum of a bounded type.

Constructors

BoundedMin |
Fields getBoundedMin :: a

Instances

Eq a => Eq (BoundedMin a) # |
Methods (==) :: BoundedMin a -> BoundedMin a -> Bool # (/=) :: BoundedMin a -> BoundedMin a -> Bool #
Ord a => Ord (BoundedMin a) # |
Methods compare :: BoundedMin a -> BoundedMin a -> Ordering # (<) :: BoundedMin a -> BoundedMin a -> Bool # (<=) :: BoundedMin a -> BoundedMin a -> Bool # (>) :: BoundedMin a -> BoundedMin a -> Bool # (>=) :: BoundedMin a -> BoundedMin a -> Bool # max :: BoundedMin a -> BoundedMin a -> BoundedMin a # min :: BoundedMin a -> BoundedMin a -> BoundedMin a #
Show a => Show (BoundedMin a) # |
Methods showsPrec :: Int -> BoundedMin a -> ShowS # show :: BoundedMin a -> String # showList :: [BoundedMin a] -> ShowS #
(Ord a, Bounded a) => Monoid (BoundedMin a) # |
Methods mempty :: BoundedMin a # mappend :: BoundedMin a -> BoundedMin a -> BoundedMin a # mconcat :: [BoundedMin a] -> BoundedMin a #